import*as HighScore from"./high_score.js";import*as Options from"./options.js";import*as GameMenu from"./game_menu.js";import Dialog from"./dialog.js";import Timer from"./timer.js";import Grid from"./grid.js";import Square,{SquareValue,SquareState}from"./square.js";import{addCanvasListeners,getCanvasRect}from"./main.js";import{getRandomInt,timeToString}from"./utilities.js";let GRID,TIMER,MINES_LEFT,DIALOG,CURRENT_MOUSE_OVER=null;export function init(){HighScore.load(),GameMenu.init(),buildGrid(),TIMER=new Timer({update:GameMenu.updateTimer}),addCanvasListeners(mouseMove,mouseClick),document.addEventListener("keydown",e=>{"r"===e.key&&(DIALOG||restart())})}function buildGrid(){const e=Options.getOption("columnSize"),t=Options.getOption("lineSize");MINES_LEFT=Options.getOption("numberOfMines"),GRID=new Grid({columnSize:e,lineSize:t,onStateChange:(e,t)=>{t===SquareState.mine_flag?updateMinesLeft(-1):e===SquareState.mine_flag&&updateMinesLeft(1)}}),GameMenu.updateScores(),GameMenu.updateMinesLeft(MINES_LEFT)}export function placeMapValues(e){if(!GRID)throw new Error("Grid not available.");const t=Options.getOption("columnSize"),n=Options.getOption("lineSize"),i=Options.getOption("numberOfMines"),a=[];for(let i=0;i<t;i++)for(let t=0;t<n;t++)i===e.column&&t===e.line||a.push({column:i,line:t});for(let e=0;e<i&&0!==a.length;e++){const e=getRandomInt(0,a.length-1),t=a.splice(e,1)[0];GRID.getSquare(t.column,t.line).setValue(SquareValue.mine)}GRID.forEachSquare(function(e){if(e.getValue()!==SquareValue.mine){const t=GRID.minesAround(e.column,e.line);e.setValue(t)}})}export function restart(){GRID&&(GRID.clear(),GRID=null),buildGrid(),TIMER.reset()}function revealSquare(e){if(!GRID)throw new Error("Grid not available.");TIMER.isActive()||(placeMapValues({column:e.column,line:e.line}),TIMER.start()),GRID.revealSquare(e);const t=e.getValue();t!=SquareValue.mine?(t===SquareValue.blank&&GRID.revealSquaresAround(e),GRID.areAllHiddenSquaresMines()&&gameOver(!0)):gameOver(!1)}function revealAllMines(){if(!GRID)throw new Error("Grid not available");GRID.forEachSquare(function(e){e.getValue()===SquareValue.mine&&GRID.revealSquare(e)})}function mouseMove(e){if(!GRID)throw new Error("Grid not available");var t=getCanvasRect(),n=e.clientX-t.left,i=e.clientY-t.top,a=Math.floor(n/Square.size),r=Math.floor(i/Square.size),o=GRID.getSquare(a,r);o?(CURRENT_MOUSE_OVER&&o!==CURRENT_MOUSE_OVER&&CURRENT_MOUSE_OVER.unSelect(),CURRENT_MOUSE_OVER=o,o.select()):CURRENT_MOUSE_OVER&&(CURRENT_MOUSE_OVER.unSelect(),CURRENT_MOUSE_OVER=null)}function mouseClick(e){if(CURRENT_MOUSE_OVER){const t=e.button,n=CURRENT_MOUSE_OVER.getState();let i=null;if(n===SquareState.revealed)return;0===t&&n===SquareState.hidden?revealSquare(CURRENT_MOUSE_OVER):1===t?i=n===SquareState.question_mark?SquareState.hidden:SquareState.question_mark:2===t&&(i=n===SquareState.mine_flag?SquareState.hidden:SquareState.mine_flag),null!==i&&(CURRENT_MOUSE_OVER.setState(i),CURRENT_MOUSE_OVER.select())}}function gameOver(e){TIMER.stop(),revealAllMines();let t="",n="";if(e){const e=TIMER.getElapsedTime(),i=Options.getOption("columnSize"),a=Options.getOption("lineSize"),r=Options.getOption("numberOfMines");HighScore.add(i,a,r,e),t="Victory!",n=`Time: ${timeToString(e)}`}else t="Defeat!",n=":(";DIALOG=new Dialog({title:t,body:n,buttonText:"Restart",onClose:()=>{restart(),DIALOG=void 0}})}function updateMinesLeft(e){MINES_LEFT+=e,GameMenu.updateMinesLeft(MINES_LEFT)}